L8. Longest Repeating Character Replacement | 2 Pointers and Sliding Window Playlist

Sdílet
Vložit
  • čas přidán 20. 08. 2024
  • Notes/Codes/Problem links under step 10 of A2Z DSA Course: takeuforward.o...
    Entire playlist: • Two Pointer and Slidin...
    Follow us on our other social media handles: linktr.ee/take...

Komentáře • 89

  • @iam_bantu
    @iam_bantu Před 4 měsíci +53

    striver bro please upload the greedy playlist asap .. ur lectures are literally dominating all dsa premium courses.. far more better than anyone

  • @prasun1595
    @prasun1595 Před 27 dny +3

    dude from 2n to n , kudos to you cuz my mind aint gone beyond that!

  • @kamalakannanng4206
    @kamalakannanng4206 Před 4 měsíci +30

    Striver - The G.O.A.T of DSA 💥

  • @akworld2739
    @akworld2739 Před 3 měsíci +154

    lagta hai jindgi tutorial dekte dekte nikal jayigi

    • @evilgame6197
      @evilgame6197 Před 2 měsíci +15

      kasam s ...sala karne betho to ye kese krenge...bas yahi chlta h

    • @anandunique1472
      @anandunique1472 Před měsícem +3

      sahi kaha bhaiya😂koi qn sliding window me slove nahi ho raha he

    • @amitmehta2285
      @amitmehta2285 Před měsícem +2

      @@anandunique1472 wahi sabse jyda aata hain 🤣

    • @rishujeetrai5780
      @rishujeetrai5780 Před měsícem +4

      mt dekho tutorial.. khud se code likho fir socho kya glt h. Key Tip: Dry Run your code with pen and paper. At last, kch smjh na aae to tutorial dekho approach smjhne k liye bs.

    • @Bhalu-kl7sq
      @Bhalu-kl7sq Před měsícem

      @@rishujeetrai5780 mein to aise kr raha tha pehle video solution dekho then khud try karo

  • @user-nm2wc1tt9u
    @user-nm2wc1tt9u Před 2 měsíci +10

    Optimal:
    class Solution {
    public:
    int characterReplacement(string s, int k) {
    int n = s.size();
    int left = 0, right = 0, maxFreq = 0, maxLen = 0;
    int hash[26] = {0};
    while(right maxFreq){
    maxFreq = hash[s[right]-'A'];
    };
    if((right-left+1)-maxFreq > k){ //trimming the left portion
    hash[s[left]-'A']--;
    left++;
    }
    maxLen = max(maxLen, right-left+1);
    right++;
    }
    return maxLen;
    }
    };

    • @beinginnit
      @beinginnit Před měsícem +2

      Though this code runs gets accepted in LC, but i think something is missing: if((right-left+1)-maxFreq > k){ //trimming the left portion
      hash[s[left]-'A']--;
      left++;
      } what if my maxFreq was from i part and also contributing, here i need to recalculate the max freq. I may be wrong but this is what i think.

    • @nadellahridayesh3571
      @nadellahridayesh3571 Před měsícem

      @@beinginnit Yeah,I see that,but it neetcode channel also he explained in this way to optimize more to O(1) space like this,please have a look at it and explain

  • @paragroy5359
    @paragroy5359 Před 3 měsíci +9

    Last 5 minutes are very precious, it is a must watch.
    That trick could be used in other questions as well for optimisation.

    • @rushidesai2836
      @rushidesai2836 Před 4 dny

      That he has been mentioning in his previous videos as well.

  • @pailatejeswararao4572
    @pailatejeswararao4572 Před 2 měsíci +2

    Thankyou very much man.I have watched 6 videos and solved this solution optimally by my own.I will learn everything from you 🙂

  • @az-zm4ji
    @az-zm4ji Před 2 měsíci +2

    First solution witout optimization:
    class Solution {
    public:
    int characterReplacement(string s, int k) {
    //FML
    int l = 0, r = 0, ans = 0, maxf = 0;
    unordered_map umap;
    while(r < s.length()){
    char c = s[r];
    if(umap.find(c) == umap.end()) umap.insert({c, 1});
    else umap.find(c)->second++;
    maxf = max(maxf, umap.find(c)->second);
    while(r - l + 1 - maxf > k){
    umap.find(s[l])->second--;
    for(auto x : umap){
    maxf = max(maxf, x.second);
    }
    l++;
    }
    ans = max(ans, r - l + 1);
    r++;
    }
    return ans;
    }
    };

  • @kapilrules
    @kapilrules Před 3 dny

    Thank you brother. I understood it because of you !🙏

  • @madhvishrivastava3646
    @madhvishrivastava3646 Před měsícem

    Bro when you explain it becomes so easy to understand.. Thank you so much :)

  • @ayaaniqbal3531
    @ayaaniqbal3531 Před 4 měsíci +8

    After understanding the logic and without seeing the solution now i am able to code it myself.
    Thanks striver for making us understand this algorithm.😊

    • @kaushit
      @kaushit Před 3 měsíci

      Ok let's understand how much you really know the depth. give me pattern of all substring in ABC string with k=1.

    • @shibainu7500
      @shibainu7500 Před 3 měsíci +2

      @@kaushit {"A", "B", "C", "AB", "BC"} hi hoga na ?

  • @sahilsukhdeve4695
    @sahilsukhdeve4695 Před měsícem +2

    Java Code for java language forks
    class Solution {
    public int characterReplacement(String s, int k) {
    int n=s.length();
    int maxlen=0,maxf=0;
    int i=0,j=0;
    Mapmap=new HashMap();
    while(jk){
    char ch2=s.charAt(i);
    map.put(ch2,map.get(ch2)-1); //decrement the frequency
    i++;
    }
    // if((j-i+1)+maxf

  • @nirmalgurjar8181
    @nirmalgurjar8181 Před 3 měsíci +5

    Trick is we dont want to minimize our max freq variable to get better result, ie. if we get result for max freq 3 we will continue to look for max freq greater than 3 if it exists and ignore freq less than equal 3. This will eliminate need of freq map scan and also remove while loop if we want to look for better max length.

  • @raghavmanish24
    @raghavmanish24 Před měsícem

    you are the legend for dsa ......thanks again striver

  • @rajharsh3739
    @rajharsh3739 Před 4 měsíci +50

    Bhaiya I am very much Greedy for your Greedy Playlist So when you are uploading that ?? 🙌🙌🤑🤑

    • @tejasjaulkar9658
      @tejasjaulkar9658 Před 4 měsíci +4

      yes we want greedy playlist bhaiyyaa

    • @dhruvmishra9781
      @dhruvmishra9781 Před 4 měsíci +3

      same bro plz give greedy playlist after this much needed

  • @stith_pragya
    @stith_pragya Před 3 měsíci +1

    UNDERSTOOD....Thank You So Much for this wonderful video......🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻

  • @oyeesharme
    @oyeesharme Před 6 dny

    it was quite tough but understood bhaiya

  • @Shivi32590
    @Shivi32590 Před 26 dny +1

    understood

  • @paragroy5359
    @paragroy5359 Před 3 měsíci +1

    keep on making such videos, thanks a lot
    Great Content

  • @ShahNawaz-cx3pi
    @ShahNawaz-cx3pi Před 2 měsíci +2

    C++ Leetcode solution:
    class Solution {
    public:
    int characterReplacement(string s, int k) {
    int n = s.size();
    int l = 0;
    int r = 0;
    int ans = 0;
    int hash[26]={0};
    int maxFre = 0;
    while(rmaxFre){
    maxFre = hash[s[r]-'A'];
    }
    if((r-l+1)-maxFre>k) {
    hash[s[l]-'A']--;
    l++;
    }
    ans = max(ans, r-l+1);
    r++;
    }
    return ans;
    }
    };

  • @ugthesep5706
    @ugthesep5706 Před 29 dny

    Did all the questions of sliding windows by myself with the optimal solutions. Just leaving the fruit in basket one.
    Watch the video to know all the possible ways of solving that particular problem ;>
    Easy Peasy Lemon Squeezy 😅

  • @adarshmv261
    @adarshmv261 Před 3 měsíci +2

    Please upload the code.. And looking forward for Heaps playlist please. Nowhere in youtube heaps problems are covered.. Please do it 🙏🏼🙏🏼🙏🏼🙏🏼 . It's being asked in interviews many times

  • @sahilshinde3724
    @sahilshinde3724 Před 4 měsíci +4

    You are writing it in very very small font can u please write which could be visible properly !
    Thanks

  • @dayashankarlakhotia4943
    @dayashankarlakhotia4943 Před 4 měsíci +2

    public int characterReplacement(String s,int k){
    int[]freq=new int[26];
    char[]ans=s.toCharArray();
    int n=ans.length,l=0,max=0;
    for(int r=0;r

  • @user-sz1rm7bj7r
    @user-sz1rm7bj7r Před 4 měsíci +2

    Great bro !

  • @vageshnp6792
    @vageshnp6792 Před dnem

    what data structure is used to store hashmap please anyone tell me?

  • @KshitijTakarkhede
    @KshitijTakarkhede Před měsícem +1

    Hey peeps , I didn't get "while loop removing to if" can you please elaborate ( it will help alot)

  • @dhruvdangi8923
    @dhruvdangi8923 Před 2 měsíci

    sir what a video this is just amazing 🙏🙌🙌🔻

  • @shashankvashishtha4454
    @shashankvashishtha4454 Před měsícem

    O((n + n)) logic is failing on AABABBB, we cannot because of the while loop directly jump to a point where some ans is missed out, if we write if instead of while (like in logic 3) then it will work.

  • @torishi82
    @torishi82 Před 2 měsíci

    Awesome brother. Understood.

  • @TARUNRAO-oe8bm
    @TARUNRAO-oe8bm Před 2 měsíci +2

    Striver bhaiya, I didnt understand why didnt we update the maxf when we are incrementing l. because the max trip will also change right when we change shorten the length of the subarray from front?

    • @sparksfly4421
      @sparksfly4421 Před měsícem +1

      you're talking about his most optimal approach, i presume. In that case he didn't modify the maxfreq variable under the inner while loop because we don't need a maxfreq variable less than the current maxfreq variable regardless of the trimmed down substring we have right now. that's because, say, the current length of the substring is lesser but we still have the maxfreq value pertaining to the previous valid substring; in this case we simply would not require to have to check the length and change the consequent letters, we'd just ignore it. And to optimize it further, instead of looping through the letters till we get the valid window of (current_length - max_freq) > k, we could replace it with 'if' to check the condition only once because we can again simply ignore the additional trouble of having to loop through for each invalid checks which striver explains why in the other videos of his

    • @oyeesharme
      @oyeesharme Před 6 dny +1

      @@sparksfly4421 thanks bhai

  • @mradulmaheshwari9353
    @mradulmaheshwari9353 Před 4 měsíci +4

    Even if you don't update the maxfreq in while loop of left then also it is working smoothly.
    Although thanks for wonderfull series striver .
    code - class Solution {
    public int characterReplacement(String s, int k) {
    int[] hash=new int[26];
    int maxlen=Integer.MIN_VALUE;
    int maxfreq=Integer.MIN_VALUE;
    int l=0;
    int n=s.length();
    for(int r=0;rk){
    char cl=s.charAt(l);
    hash[cl-'A']--;
    l++;
    }
    maxlen=Math.max(maxlen,r-l+1);
    }
    return maxlen;
    }
    }

    • @fractionofinfinity842
      @fractionofinfinity842 Před 3 měsíci

      Why would this work? Also once let's say maxfreq is 3 because of 'A', and then if we remove 'A' from the window how do we update maxfreq from 3 to 2 assuming no other char having freq 3?

    • @Dsa_kabaap
      @Dsa_kabaap Před 3 měsíci +1

      ​@@fractionofinfinity842actually we don't need to update the maxf value to the lesser value . Becz if u update it to lesser value like 2 , again it will come under > k while condition .

    • @Rahul_Mongia
      @Rahul_Mongia Před 2 měsíci +2

      use if (r-l+1-maxf>k) rather than while

  • @devgarg4331
    @devgarg4331 Před 4 měsíci +4

    Bhaia will not the time complexity be N + 26(N) = 27N ??

  • @Ultra_InstinctBit.h
    @Ultra_InstinctBit.h Před 2 měsíci +1

    can we use use mapping for frequency calculations?

  • @saketjaiswal9381
    @saketjaiswal9381 Před 4 měsíci +1

    hacker as always thanks bro

  • @shashankvashishtha4454
    @shashankvashishtha4454 Před měsícem

    int window3(string& s,int k){ //O(n) most optimal pure O(n) logic
    int i=0;
    int j=0;
    int len=0;
    int max_freq=0;
    vectorfreq(26,0);
    while(j < n){
    freq[s[j] - 'A']++;
    max_freq = max(max_freq,freq[s[j] - 'A']);
    if((j-i+1) - max_freq > k){
    freq[s[i]-'A']--;
    i++;
    // max_freq = 0;//use less
    //max_freq = *max_element(freq.begin(),freq.end());//it will make no sense to calculate max freq here in if part we will get max in next iteration with line: max_freq = max(max_freq,freq[s[j] - 'A']);
    }else{
    len = max(len,j-i+1);
    }
    j++;
    }
    return len;
    }
    this is most optimal logic, max_freq = 0, logic not clear to me and it is even not working with while version of this function, but this one is intuitive and clear.

  • @tejaswaniguttula5961
    @tejaswaniguttula5961 Před 4 měsíci

    Hi anna....!!!
    I am super excited with your sliding window protocol series. I understood every video till now in this series except this video with the difference between only if condition and inner while loop and its inner for loop. Could you please elaborate it in depth with some specific examples. So, that I can understand the thought process behind it. Please please anna...😊😊😊

    • @nirmalgurjar8181
      @nirmalgurjar8181 Před 3 měsíci +1

      Trick is we dont want to minimize our max freq variable to get better result, ie. if we get result for max freq 3 we will continue to look for max freq greater than 3 if it exists and ignore freq less than equal 3. This will eliminate need of freq map scan and also remove while loop if we want to look for better max length.

    • @Aryan-rb3yk
      @Aryan-rb3yk Před 2 měsíci

      @@nirmalgurjar8181 aaah i get it now ,thanks i got the 26 for loop part , but not the inner while loop part

  • @sachinkumarsharma6483
    @sachinkumarsharma6483 Před 19 dny

    class Solution {
    public:
    int characterReplacement(string s, int k) {
    int n = s.size();
    int l=0,r = 0,maxf = 0,maxlen = 0;
    mapmpp;
    while(rk)
    {
    mpp[s[l]]--;
    l = l+1;
    }
    maxlen = max(maxlen,r-l+1);
    r++;
    }
    return maxlen;
    }
    };

  • @psinity
    @psinity Před 2 měsíci +1

    19:20 the time complexity should be O( N + N*26) right?

  • @KartikeyTT
    @KartikeyTT Před měsícem

    ty sir

  • @kiranchavan2632
    @kiranchavan2632 Před měsícem

    Where i can find sudo code?

  • @everydaycodingwithgiyusama6949
    @everydaycodingwithgiyusama6949 Před 3 měsíci +1

    Is the naive or brute force code work properly for all test cases ? IF YES CAN ANYONE FIND ERROR IN MY CODE because It does not satisfy test case 2 of leetcode
    int[] arr = new int[26];
    int maxc = 0;
    int maxl = 0;
    for(int i = 0; i< s.length();i++){
    for(int j = i ; j < s.length() ; j++){
    arr[s.charAt(j) - 'A']++;
    maxc = Math.max(maxc,arr[s.charAt(j)-'A']);
    if( (j - i + 1 ) - maxc

    • @ayushgakre9450
      @ayushgakre9450 Před 3 měsíci

      int[] arr = new int[26]; should be after first loop bcz in next iteration is should be updated to 0

  • @mansisethi8127
    @mansisethi8127 Před 3 měsíci

    I didn't understand , why we are doing maxf=0 in the else part. Can someone please explain ?

    • @Aryan-rb3yk
      @Aryan-rb3yk Před 2 měsíci

      I guess he did it initially as we was going to check again for the max freq using that 0-26 for loop its not in else everything is in if I guess

  • @rayhangafoor4204
    @rayhangafoor4204 Před 2 měsíci

    ugh im not able to understand the maxFreq optimization logic

  • @ananttripathi6190
    @ananttripathi6190 Před 3 měsíci

    why we are doing " -'A' " in hash[S[r]-'A' ????

    • @parahunter1650
      @parahunter1650 Před 3 měsíci +1

      S[r]-'A' will give a integer value which we will use for indexing in our hash map
      For example if s[r]=B
      So, 'B'-'A'(i.e 66-65(ASCII VALUES OF B AND A) =1)
      So hash[1] will increase

  • @tarunkr4698
    @tarunkr4698 Před 19 dny

    mera ho gya hai dimag kharab iss question se

  • @asad_iliyas
    @asad_iliyas Před 2 měsíci

    understood++

  • @Mohit_Q
    @Mohit_Q Před měsícem

    28 June 2024 4:49pm

  • @aryankumar3018
    @aryankumar3018 Před 14 dny

    US

  • @paarth_bhasin
    @paarth_bhasin Před 4 měsíci +1

    where is the code in all 3 languages???

  • @shivsankarsuthar
    @shivsankarsuthar Před 2 měsíci

    bhai writing thoda shi se kro , smjh ni aata kya likha h, piche jake dekhna pdta h

  • @user-gk4zy6bk7l
    @user-gk4zy6bk7l Před 3 měsíci

    God

  • @raghavmanish24
    @raghavmanish24 Před měsícem +1

    understood

  • @ramakrishnakcr4417
    @ramakrishnakcr4417 Před 4 měsíci +1

    understood

  • @rlm3227
    @rlm3227 Před 2 měsíci

    understood

  • @abhinanda7049
    @abhinanda7049 Před 2 měsíci

    understood